package jsfdemo;

import java.text.MessageFormat;
import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import javax.faces.context.FacesContext;

/**
 * 
 * @author Vladimir Tsanev
 * 
 */
public final class FacesBundlesUtils {
	private static final Object NO_PARAMS_ARRAY = new Object[] {};

	private FacesBundlesUtils() {
		// This is an utility class
	}

	public static String getMessage(String key, Object... params) {
		FacesContext facesContext = FacesContext.getCurrentInstance();
		Locale locale = facesContext.getViewRoot().getLocale();
		String bundleName = facesContext.getApplication().getMessageBundle();
		String message = null;
		try {
			ResourceBundle bundle = ResourceBundle
					.getBundle(bundleName, locale);
			message = bundle.getString(key);
			if (params != null && params.length > 0) {
				MessageFormat mf = new MessageFormat(message, locale);
				message = mf.format(params, new StringBuffer(), null)
						.toString();
			}
		} catch (MissingResourceException e) {
			message = "???" + key + "???";
		}
		return message;
	}

	public static String getMessage(String key) {
		return getMessage(key, NO_PARAMS_ARRAY);
	}

}
